﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;

namespace TileView_DataBinding
{
	public partial class MainPage : UserControl
	{
		private int lastImageIndex;

		public MainPage()
		{
			InitializeComponent();
			this.lastImageIndex = 0;
			this.tileView.ItemsSource = this.GenerateData();
		}

		private int GetImageIndex()
		{
			this.lastImageIndex = (this.lastImageIndex >= 6) ? 1 : ++this.lastImageIndex;
			return this.lastImageIndex;
		}

		private ObservableCollection<Product> GenerateData()
		{
			ObservableCollection<Product> result = new ObservableCollection<Product>();

			ObservableCollection<Product> subProducts = new ObservableCollection<Product>();
			for (int i = 0; i < 5; i++)
			{
				subProducts.Add(
					new Product()
					{
						ProductName = String.Format("SubProduct {0}", i),
						ProductPrice = 1 + i,
						ImagePath = String.Format("Images/{0}.png", this.GetImageIndex()),
						ProductDescription = String.Format("Description of SubProduct {0}", i)
					});
			}

			foreach (var i in Enumerable.Range(0, 9))
			{
				result.Add(new Product()
				{
					ProductName = String.Format("Product {0}", i),
					ProductPrice = 10 + i,
					ImagePath = String.Format("Images/{0}.png", this.GetImageIndex()),
					ProductDescription = String.Format("Description of Product {0}", i),
					SubProducts = subProducts
				});
			}

			return result;
		}

		private void tileView_TileStateChanged(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			e.Handled = true;
			RadTileViewItem item = e.OriginalSource as RadTileViewItem;
			if (item != null)
			{
				var fluidControls = item.ChildrenOfType<RadFluidContentControl>();
				if (fluidControls.Count == 0)
				{
					return;
				}
				RadFluidContentControl fluidControl = fluidControls[0];

				switch (item.TileState)
				{
					case TileViewItemState.Maximized:
						fluidControl.State = FluidContentControlState.Large;
						break;
					case TileViewItemState.Minimized:
						fluidControl.State = FluidContentControlState.Small;
						break;
					case TileViewItemState.Restored:
						fluidControl.State = FluidContentControlState.Normal;
						break;
				}
			}
		}
	}
}
